///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit ItemsIdbR1Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TItemsIdbR1F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  ItemsIdbR1F: TItemsIdbR1F;
  PathForForm, MaskaNam, FileNam, Unknown2, ShablonsPath : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk2Siz : integer;
                                            
implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TItemsIdbR1F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  ItemsIdbR1FClosed := true;
  MainForm.LmpItemsMenu1.Checked := false;
  Action := CaFree;
end;



procedure TItemsIdbR1F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  ItemsIdbR1FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';
  ValuesEd.Cells[1,18] := '';
  ValuesEd.Cells[1,19] := '';
  ValuesEd.Cells[1,20] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaselmpResIsh;     //  
  PathForForm := IshDir+'items\1\';     //   
  ShablonsPath := Path+'shablons\items\1\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;

        //  (     )
        //   
        //  ...
        Num := _4byteStrToUnsLong(Zap1.GetField(4));
        If Num <> I-1 then begin
          //   ....
          //...
          Num := I-1;
          Zap1.ReWriteField(4,4,UnsLongTo4byteStr(Num));
          Zap1.BuildZap;
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+Indeks[I,1]);
        end;
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;



procedure TItemsIdbR1F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;


procedure TItemsIdbR1F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TItemsIdbR1F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .

  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //Material Type -  2  TEXT.
  ValuesEd.Cells[1,2] := PzDbStrToStr(Zap1.GetField(2));

  //Material Code Name -  3  TEXT.
  ValuesEd.Cells[1,3] := PzDbStrToStr(Zap1.GetField(3));

  //Unknown1 ( ) -  4  UnsLong.
  ValuesEd.Cells[1,4] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(4)));

  //General Price -  5  FLOAT.
  ValuesEd.Cells[1,5] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(5)),7));

  //General Weight -  6  FLOAT.
  ValuesEd.Cells[1,6] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(6)),7));

  //General Mana -  7  FLOAT.
  ValuesEd.Cells[1,7] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(7)),7));

  //General Slots -  8  UnsLong.
  ValuesEd.Cells[1,8] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(8)));

  //General Durability -  9  FLOAT.
  ValuesEd.Cells[1,9] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(9)),7));

  //Material Skill -  10  UnsLong.
  ValuesEd.Cells[1,10] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(10)));

  //Material Damage -  11  FLOAT.
  ValuesEd.Cells[1,11] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(11)),7));

  //Absorption -  12   -    , 7 FLOAT .
  BufSt := Zap1.GetField(12);
  //Absorption Piercing. FLOAT. -  1.
  ValuesEd.Cells[1,12] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Absorption Slashing. FLOAT. -  2.
  ValuesEd.Cells[1,13] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Absorption Bludgeoning. FLOAT. -  3.
  ValuesEd.Cells[1,14] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Absorption Termal. FLOAT. -  4.
  ValuesEd.Cells[1,15] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Absorption Chemic. FLOAT. -  5.
  ValuesEd.Cells[1,16] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Absorption Electric. FLOAT. -  6.
  ValuesEd.Cells[1,17] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Absorption General. FLOAT. -  7.
  ValuesEd.Cells[1,18] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Unknown2 -  13   ,  4  .
  Unknown2 := Zap1.GetField(13);
  Unk2Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,19] := GetUnkStr(Unknown2,Unk2Siz);

  //ShopInfo -  14.
  ValuesEd.Cells[1,20] := UnsLongToShopInfo(_4byteStrToUnsLong(Zap1.GetField(14)));
  
end;

Function TItemsIdbR1F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';
  
  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,4]) = false then begin
    AllOk := false;
    //Unknown1 -  
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '    .';
    Beep;
  end
  else if StrToInt(ValuesEd.Cells[1,4]) <> MaskiBox.ItemIndex then begin
    AllOk := false;
    //Unknown1 -   .
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '       -1.    '+IntToStr(MaskiBox.ItemIndex);
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,5]) = false then begin
    AllOk := false;
    //General Price
    ValuesEd.Selection := SelGridRect(1,5);
    ErrorMsgStr := '    .';
    Beep;
  end;

   if CheckStrFloat(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //General Weight
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //General Mana
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //General Slots
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,9]) = false then begin
    AllOk := false;
    //General Durability
    ValuesEd.Selection := SelGridRect(1,9);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,10]) = false then begin
    AllOk := false;
    //Material Skill
    ValuesEd.Selection := SelGridRect(1,10);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,11]) = false then begin
    AllOk := false;
    //Material Damage
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,12]) = false then begin
    AllOk := false;
    //Absorption Piercing
    ValuesEd.Selection := SelGridRect(1,12);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,13]) = false then begin
    AllOk := false;
    //Absorption Slashing
    ValuesEd.Selection := SelGridRect(1,13);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,14]) = false then begin
    AllOk := false;
    //Absorption Bludgeoning
    ValuesEd.Selection := SelGridRect(1,14);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,15]) = false then begin
    AllOk := false;
    //Absorption Termal
    ValuesEd.Selection := SelGridRect(1,15);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,16]) = false then begin
    AllOk := false;
    //Absorption Chemic
    ValuesEd.Selection := SelGridRect(1,16);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,17]) = false then begin
    AllOk := false;
    //Absorption Electric
    ValuesEd.Selection := SelGridRect(1,17);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,18]) = false then begin
    AllOk := false;
    //Absorption General
    ValuesEd.Selection := SelGridRect(1,18);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckShopInfo(ValuesEd.Cells[1,20]) = false then begin
    AllOk := false;
    //Absorption General
    ValuesEd.Selection := SelGridRect(1,20);
    ErrorMsgStr := '    .      ,  ,      (   )';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin
  
    //Name.  1. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,1]);
    //  ...
    Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Material Type.  2. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,2]);
    //  ...
    Zap1.ReWriteField(2,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Material Code Name.  3. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,3]);
    //  ...
    Zap1.ReWriteField(3,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Unknown1.  4. UnsLong.
    Zap1.ReWriteField(4,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,4])));

    //General Price.  5. FLOAT.
    Zap1.ReWriteField(5,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,5])));

    //General Weight.  6. FLOAT.
    Zap1.ReWriteField(6,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,6])));

    //General Mana.  7. FLOAT.
    Zap1.ReWriteField(7,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,7])));

    //General Slots.  8. UnsLong.
    Zap1.ReWriteField(8,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,8])));

    //General Durability.  9. FLOAT.
    Zap1.ReWriteField(9,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,9])));

    //Material Skill.  10. UnsLong.
    Zap1.ReWriteField(10,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,10])));

    //Material Damage.  11. FLOAT.
    Zap1.ReWriteField(11,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,11])));

    //Absorption.  12. 7 FLOAT .
    BufSt := '';
    //Absorption Piercing
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,12]));
    //Absorption Slashing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,13]));
    //Absorption Bludgeoning
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,14]));
    //Absorption Termal
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,15]));
    //Absorption Chemic
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,16]));
    //Absorption Electric
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,17]));
    //Absorption General
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,18]));
    Zap1.ReWriteField(12,28,BufSt);

    //Unknown2.  13.    .
    Zap1.ReWriteField(13,Unk2Siz,Unknown2);

    //ShopInfo.  14.
    Zap1.ReWriteField(14,4,UnsLongTo4byteStr(ShopInfoToUnsLong(ValuesEd.Cells[1,20])));

    //  ...
    Zap1.BuildZap;
    result := true;
  end          
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TItemsIdbR1F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[18].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TItemsIdbR1F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[18].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to ItemsIdbR1F.MaskiBox.Items.Capacity-1 do begin
    If ItemsIdbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to ItemsIdbR1F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If ItemsIdbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TItemsIdbR1F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;  
end;



procedure TItemsIdbR1F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;



procedure TItemsIdbR1F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TItemsIdbR1F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;



procedure TItemsIdbR1F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;



procedure TItemsIdbR1F.ValuesEdEditButtonClick(Sender: TObject);
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin
  
    If ValuesEd.Row = 19 then begin
      //ShowMessage('   '+IntToStr(19));

      //1,   UnsLong.  4 .
      //,     ...
      UncAskF.UncAskFBuff := Unknown2;
      UncAskF.UncAskFBytes := Unk2Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown2 := UncAskF.UncAskFBuff;
          Unk2Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,19] := GetUnkStr(Unknown2,Unk2Siz);
        end;
      end;
    end;
  end;
end;

procedure TItemsIdbR1F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
