///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit ItemsIdbR4Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TItemsIdbR4F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  ItemsIdbR4F: TItemsIdbR4F;
  PathForForm, MaskaNam, FileNam,ShablonsPath,
  Unknown1, Unknown2, Unknown3, Unknown4, Unknown5 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz, Unk2Siz, Unk3Siz, Unk4Siz, Unk5Siz : integer;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TItemsIdbR4F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  ItemsIdbR4FClosed := true;
  MainForm.LmpItemsMenu4.Checked := false;
  Action := CaFree;
end;

procedure TItemsIdbR4F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  ItemsIdbR4FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';
  ValuesEd.Cells[1,18] := '';
  ValuesEd.Cells[1,19] := '';
  ValuesEd.Cells[1,20] := '';
  ValuesEd.Cells[1,21] := '';
  ValuesEd.Cells[1,22] := '';
  ValuesEd.Cells[1,23] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaselmpResIsh;     //  
  PathForForm := IshDir+'items\4\';     //   
  ShablonsPath := Path+'shablons\items\4\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TItemsIdbR4F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TItemsIdbR4F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TItemsIdbR4F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //Quick Items Type -  2  TEXT.
  ValuesEd.Cells[1,2] := PzDbStrToStr(Zap1.GetField(2));

  //Unknown1 -  3   ,  4  .
  Unknown1 := Zap1.GetField(3);
  Unk1Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,3] := GetUnkStr(Unknown1,Unk1Siz);

  //Quick Items Material Type -  4  TEXT.
  ValuesEd.Cells[1,4] := PzDbStrToStr(Zap1.GetField(4));

  //Unknown2 -  5   ,  4  .
  Unknown2 := Zap1.GetField(5);
  Unk2Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,5] := GetUnkStr(Unknown2,Unk2Siz);

  //Graphics Data Texture Type Index -  6  UnsLong.
  ValuesEd.Cells[1,6] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(6)));

  //Graphics Data Texture Type Index2 -  7  UnsLong.
  ValuesEd.Cells[1,7] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(7)));

  //General Price -  8  FLOAT.
  ValuesEd.Cells[1,8] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(8)),7));

  //General Weight -  9  FLOAT.
  ValuesEd.Cells[1,9] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(9)),7));

  //General Size -  10  FLOAT.
  ValuesEd.Cells[1,10] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(10)),7));

  //General Mana -  11  FLOAT.
  ValuesEd.Cells[1,11] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(11)),7));

  //General Slots -  12  UnsLong.
  ValuesEd.Cells[1,12] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(12)));

  //General Durability -  13  FLOAT.
  ValuesEd.Cells[1,13] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(13)),7));

  //General Components -  14  UnsLong.
  ValuesEd.Cells[1,14] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(14)));

  //ShopInfo -  15.
  ValuesEd.Cells[1,15] := UnsLongToShopInfo(_4byteStrToUnsLong(Zap1.GetField(15)));

  //General Deconstructable -  16  BOOLEAN.
  ValuesEd.Cells[1,16] := BoolToStr(_1byteStrToBool(Zap1.GetField(16)));

  //QItem ID -  17  UnsLong.
  ValuesEd.Cells[1,17] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(17)));

  //Graphics Data Level -  18  UnsLong.
  ValuesEd.Cells[1,18] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(18)));

  //Quick Items Damage -  19  FLOAT.
  ValuesEd.Cells[1,19] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(19)),7));

  //Unknown3 -  20   ,  4  .
  Unknown3 := Zap1.GetField(20);
  Unk3Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,20] := GetUnkStr(Unknown3,Unk3Siz);

  //Quick Items Spell -  21  TEXT.
  ValuesEd.Cells[1,21] := PzDbStrToStr(Zap1.GetField(21));

  //Unknown4 -  22   ,  3  .
  Unknown4 := Zap1.GetField(22);
  Unk4Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,22] := GetUnkStr(Unknown4,Unk4Siz);

  //Unknown5 -  23   ,  8  .
  Unknown5 := Zap1.GetField(23);
  Unk5Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,23] := GetUnkStr(Unknown5,Unk5Siz);

end;

Function TItemsIdbR4F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';
  
  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Graphics Data Texture Type Index
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //Graphics Data Texture Type Index2
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //General Price
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,9]) = false then begin
    AllOk := false;
    //General Weight
    ValuesEd.Selection := SelGridRect(1,9);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,10]) = false then begin
    AllOk := false;
    //General Size
    ValuesEd.Selection := SelGridRect(1,10);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,11]) = false then begin
    AllOk := false;
    //General Mana
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,12]) = false then begin
    AllOk := false;
    //General Slots
    ValuesEd.Selection := SelGridRect(1,12);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,13]) = false then begin
    AllOk := false;
    //General Durability
    ValuesEd.Selection := SelGridRect(1,13);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,14]) = false then begin
    AllOk := false;
    //General Components
    ValuesEd.Selection := SelGridRect(1,14);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckShopInfo(ValuesEd.Cells[1,15]) = false then begin
    AllOk := false;
    //- 
    ValuesEd.Selection := SelGridRect(1,15);
    ErrorMsgStr := '    .      ,  ,      (   )';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,16]) = false then begin
    AllOk := false;
    //General Deconstructable
    ValuesEd.Selection := SelGridRect(1,16);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,17]) = false then begin
    AllOk := false;
    //QItem ID
    ValuesEd.Selection := SelGridRect(1,17);
    ErrorMsgStr := '    .';
    Beep;
  end
  else begin
    // ID   Weapon Type.
    If ValuesEd.Cells[1,2] = 'dangersensor' then ValuesEd.Cells[1,17] := IntToStr(0);
    If ValuesEd.Cells[1,2] = 'wand' then ValuesEd.Cells[1,17] := IntToStr(5);
    If ValuesEd.Cells[1,2] = 'scroll' then ValuesEd.Cells[1,17] := IntToStr(8);
  end;

  if CheckStrInt(ValuesEd.Cells[1,18]) = false then begin
    AllOk := false;
    //Graphics Data Level
    ValuesEd.Selection := SelGridRect(1,18);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,19]) = false then begin
    AllOk := false;
    //Quick Items Damage
    ValuesEd.Selection := SelGridRect(1,19);
    ErrorMsgStr := '    .';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,1]);
    //  ...
    Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Quick Items Type.  2. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,2]);
    //  ...
    Zap1.ReWriteField(2,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Unknown1.  3.    .
    Zap1.ReWriteField(3,Unk1Siz,Unknown1);

    //Quick Items Material Type.  4. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,4]);
    //  ...
    Zap1.ReWriteField(4,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Unknown2.  5.    .
    Zap1.ReWriteField(5,Unk2Siz,Unknown2);

    //Graphics Data Texture Type Index.  6. UnsLong.
    Zap1.ReWriteField(6,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,6])));

    //Graphics Data Texture Type Index2.  7. UnsLong.
    Zap1.ReWriteField(7,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,7])));

    //General Price.  8. FLOAT.
    Zap1.ReWriteField(8,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,8])));

    //General Weight.  9. FLOAT.
    Zap1.ReWriteField(9,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,9])));

    //General Size.  10. FLOAT.
    Zap1.ReWriteField(10,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,10])));

    //General Mana.  11. FLOAT.
    Zap1.ReWriteField(11,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,11])));

    //General Slots.  12. UnsLong.
    Zap1.ReWriteField(12,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,12])));

    //General Durability.  13. FLOAT.
    Zap1.ReWriteField(13,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,13])));

    //General Components.  14. UnsLong.
    Zap1.ReWriteField(14,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,14])));

    //ShopInfo.  15.
    Zap1.ReWriteField(15,4,UnsLongTo4byteStr(ShopInfoToUnsLong(ValuesEd.Cells[1,15])));

    //General Deconstructable.  16. BOOLEAN.
    Zap1.ReWriteField(16,1,BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,16])));

    //QItem ID.  17. UnsLong.
    Zap1.ReWriteField(17,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,17])));

    //Graphics Data Level.  18. UnsLong.
    Zap1.ReWriteField(18,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,18])));

    //Quick Items Damage.  19. FLOAT.
    Zap1.ReWriteField(19,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,19])));

    //Unknown3.  20.    .
    Zap1.ReWriteField(20,Unk3Siz,Unknown3);

    //Quick Items Spell.  21. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,21]);
    //  ...
    Zap1.ReWriteField(21,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Unknown4.  22.    .
    Zap1.ReWriteField(22,Unk4Siz,Unknown4);

    //Unknown5.  23.    .
    Zap1.ReWriteField(23,Unk5Siz,Unknown5);

    //  ...
    Zap1.BuildZap;
    result := true;
  end          
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TItemsIdbR4F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[2].EditStyle := esEllipsis;
    ValuesEd.ItemProps[4].EditStyle := esEllipsis;
    ValuesEd.ItemProps[19].EditStyle := esEllipsis;
    ValuesEd.ItemProps[21].EditStyle := esEllipsis;
    ValuesEd.ItemProps[22].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TItemsIdbR4F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[2].EditStyle := esSimple;
    ValuesEd.ItemProps[4].EditStyle := esSimple;
    ValuesEd.ItemProps[19].EditStyle := esSimple;
    ValuesEd.ItemProps[21].EditStyle := esSimple;
    ValuesEd.ItemProps[22].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to ItemsIdbR4F.MaskiBox.Items.Capacity-1 do begin
    If ItemsIdbR4F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to ItemsIdbR4F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If ItemsIdbR4F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TItemsIdbR4F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;  
end;



procedure TItemsIdbR4F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;



procedure TItemsIdbR4F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TItemsIdbR4F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;



procedure TItemsIdbR4F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;



procedure TItemsIdbR4F.ValuesEdEditButtonClick(Sender: TObject);
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin
  
    If ValuesEd.Row = 3 then begin
      //1,   UnsLong.  4 .
      //,     ...
      UncAskF.UncAskFBuff := Unknown1;
      UncAskF.UncAskFBytes := Unk1Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown1 := UncAskF.UncAskFBuff;
          Unk1Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,3] := GetUnkStr(Unknown1,Unk1Siz);
        end;
      end;
    end;

    If ValuesEd.Row = 5 then begin
      //2, 4  .
      //,     ...
      UncAskF.UncAskFBuff := Unknown2;
      UncAskF.UncAskFBytes := Unk2Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown2 := UncAskF.UncAskFBuff;
          Unk2Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,5] := GetUnkStr(Unknown2,Unk2Siz);
        end;
      end;
    end;

    If ValuesEd.Row = 20 then begin
      //3, 4  .
      //,     ...
      UncAskF.UncAskFBuff := Unknown3;
      UncAskF.UncAskFBytes := Unk3Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown3 := UncAskF.UncAskFBuff;
          Unk3Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,20] := GetUnkStr(Unknown3,Unk3Siz);
        end;
      end;
    end;

    
    If ValuesEd.Row = 22 then begin
      //4, 3  .
      //,     ...
      UncAskF.UncAskFBuff := Unknown4;
      UncAskF.UncAskFBytes := Unk4Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown4 := UncAskF.UncAskFBuff;
          Unk4Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,22] := GetUnkStr(Unknown4,Unk4Siz);
        end;
      end;
    end;

    If ValuesEd.Row = 23 then begin
      //5, 8  .
      //,     ...
      UncAskF.UncAskFBuff := Unknown5;
      UncAskF.UncAskFBytes := Unk5Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown5 := UncAskF.UncAskFBuff;
          Unk5Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,23] := GetUnkStr(Unknown5,Unk5Siz);
        end;
      end;
    end;

  end;
end;

procedure TItemsIdbR4F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
