///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit ResbuildForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TResbuildF = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
    FirstPaint : boolean;
  public
    { Public declarations }
    ResFile : string;
    DirPath : string;
    ToDoCode : byte;
    ShErrMess : boolean;
    ResultStr : string;
  end;

const
  RBF_DO_NOTHING = 0;
  RBF_PACK_CODE = 1;
  RBF_UNPACK_CODE = 2;
  RBF_OPTIMIZE_CODE = 3;

var
  ResbuildF: TResbuildF;

implementation
uses initer;

{$R *.dfm}

procedure TResbuildF.FormCreate(Sender: TObject);
var
  hMenuHandle : cardinal;
begin
  // .
  //    ...
  hMenuHandle := GetSystemMenu(ResbuildF.Handle,FALSE);
  if (hMenuHandle <> 0) then begin
    //      ...
    DeleteMenu(hMenuHandle, SC_Close, MF_DISABLED);
  end;

  //    ...
  FirstPaint := false;
end;

procedure TResbuildF.FormShow(Sender: TObject);
begin
  //         .
  //  ,      ,   
  // 1 ,       OnPaint.
  FirstPaint := true;
end;

procedure TResbuildF.FormPaint(Sender: TObject);
begin
  //    .   
  //    .

  If FirstPaint = true then begin
    //      ,  . OnShow.

    FirstPaint := false;  //     1  :)

    ResbuildF.Repaint;   //         ...

    //,        ...
    If ToDoCode = 0 then begin
      // RBF_DO_NOTHING

      //  ...
      Close;
    end;

    If ToDoCode = 1 then begin
      // RBF_PACK_CODE

      // ...
      ResultStr := AddDirToRes(ResFile,DirPath);

      //    ,    , 
      //   ...
      If (ShErrMess = true) and (ResultStr <> '') then begin
        MessageBox(Handle,PChar(ResultStr),'!',MB_OK or MB_ICONERROR);
      end;
      Close;
    end;

    If ToDoCode = 2 then begin
      // RBF_UNPACK_CODE

      // ...
      ResultStr := UnPackResToDir(ResFile,DirPath);

      //    ,    , 
      //   ...
      If (ShErrMess = true) and (ResultStr <> '') then begin
        MessageBox(Handle,PChar(ResultStr),'!',MB_OK or MB_ICONERROR);
      end;
      Close;
    end;

    If ToDoCode = 3 then begin
      // RBF_OPTIMIZE_CODE

      // ...
      ResultStr := OptimizeRes(ResFile);

      //    ,    , 
      //   ...
      If (ShErrMess = true) and (ResultStr <> '') then begin
        MessageBox(Handle,PChar(ResultStr),'!',MB_OK or MB_ICONERROR);
      end;
      Close;
    end;
  end;

end;

end.
