///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit SinglAcksDbR1Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TSinglAcksDbR1F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  SinglAcksDbR1F: TSinglAcksDbR1F;
  PathForForm, MaskaNam, FileNam, ShablonsPath,
  Unknown1, ASoundField2, ASoundField3, ASoundField4,
  ASoundField5, ASoundField6, ASoundField7, ASoundField8,
  ASoundField9, ASoundField10, ASoundField11, ASoundField12,
  ASoundField13, ASoundField14, ASoundField15, ASoundField16,
  ASoundField17, ASoundField18, ASoundField19, ASoundField20,
  ASoundField21, ASoundField22, ASoundField23, ASoundField24,
  ASoundField25, ASoundField26, ASoundField27, ASoundField28,
  ASoundField29, ASoundField30, ASoundField31, ASoundField32,
  ASoundField33, ASoundField34, ASoundField35, ASoundField36 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz : integer;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TSinglAcksDbR1F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  SinglAcksDbR1FClosed := true;
  MainForm.AcksMenu1.Checked := false;
  Action := CaFree;
end;

procedure TSinglAcksDbR1F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  SinglAcksDbR1FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';
  ValuesEd.Cells[1,18] := '';
  ValuesEd.Cells[1,19] := '';
  ValuesEd.Cells[1,20] := '';
  ValuesEd.Cells[1,21] := '';
  ValuesEd.Cells[1,22] := '';
  ValuesEd.Cells[1,23] := '';
  ValuesEd.Cells[1,24] := '';
  ValuesEd.Cells[1,25] := '';
  ValuesEd.Cells[1,26] := '';
  ValuesEd.Cells[1,27] := '';
  ValuesEd.Cells[1,28] := '';
  ValuesEd.Cells[1,29] := '';
  ValuesEd.Cells[1,30] := '';
  ValuesEd.Cells[1,31] := '';
  ValuesEd.Cells[1,32] := '';
  ValuesEd.Cells[1,33] := '';
  ValuesEd.Cells[1,34] := '';
  ValuesEd.Cells[1,35] := '';
  ValuesEd.Cells[1,36] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaseResIsh;     //  
  PathForForm := IshDir+'acks\1\';     //   
  ShablonsPath := Path+'shablons\acks\1\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TSinglAcksDbR1F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TSinglAcksDbR1F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TSinglAcksDbR1F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //SelectVoice -  2  ASound.
  ASoundField2 := Zap1.GetField(2);
  ValuesEd.Cells[1,2] := GetASoundStr(ASoundField2);

  //MoveVoice -  3 ASound.
  ASoundField3 := Zap1.GetField(3);
  ValuesEd.Cells[1,3] := GetASoundStr(ASoundField3);

  //AttackVoice -  4 ASound.
  ASoundField4 := Zap1.GetField(4);
  ValuesEd.Cells[1,4] := GetASoundStr(ASoundField4);

  //CastVoice -  5 ASound.
  ASoundField5 := Zap1.GetField(5);
  ValuesEd.Cells[1,5] := GetASoundStr(ASoundField5);

  //LootVoice -  6 ASound.
  ASoundField6 := Zap1.GetField(6);
  ValuesEd.Cells[1,6] := GetASoundStr(ASoundField6);

  //UseObjVoice -  7 ASound.
  ASoundField7 := Zap1.GetField(7);
  ValuesEd.Cells[1,7] := GetASoundStr(ASoundField7);

  //StealVoice -  8 ASound.
  ASoundField8 := Zap1.GetField(8);
  ValuesEd.Cells[1,8] := GetASoundStr(ASoundField8);

  //FollowVoice -  9 ASound.
  ASoundField9 := Zap1.GetField(9);
  ValuesEd.Cells[1,9] := GetASoundStr(ASoundField9);

  //UsePotVoice -  10 ASound.
  ASoundField10 := Zap1.GetField(10);
  ValuesEd.Cells[1,10] := GetASoundStr(ASoundField10);

  //ChPosVoice -  11 ASound.
  ASoundField11 := Zap1.GetField(11);
  ValuesEd.Cells[1,11] := GetASoundStr(ASoundField11);

  //NoWayVoice -  12 ASound.
  ASoundField12 := Zap1.GetField(12);
  ValuesEd.Cells[1,12] := GetASoundStr(ASoundField12);

  //CntChPosVoice -  13 ASound.
  ASoundField13 := Zap1.GetField(13);
  ValuesEd.Cells[1,13] := GetASoundStr(ASoundField13);

  //NoPathVoice -  14 ASound.
  ASoundField14 := Zap1.GetField(14);
  ValuesEd.Cells[1,14] := GetASoundStr(ASoundField14);

  //CantCastVoice -  15 ASound.
  ASoundField15 := Zap1.GetField(15);
  ValuesEd.Cells[1,15] := GetASoundStr(ASoundField15);

  //CantTeleVoice -  16 ASound.
  ASoundField16 := Zap1.GetField(16);
  ValuesEd.Cells[1,16] := GetASoundStr(ASoundField16);

  //SkiFailVoice -  17 ASound.
  ASoundField17 := Zap1.GetField(17);
  ValuesEd.Cells[1,17] := GetASoundStr(ASoundField17);

  //NoTargetVoice -  18 ASound.
  ASoundField18 := Zap1.GetField(18);
  ValuesEd.Cells[1,18] := GetASoundStr(ASoundField18);

  //ComplSpVoice -  19 ASound.
  ASoundField19 := Zap1.GetField(19);
  ValuesEd.Cells[1,19] := GetASoundStr(ASoundField19);

  //DecToAttVoice -  20 ASound.
  ASoundField20 := Zap1.GetField(20);
  ValuesEd.Cells[1,20] := GetASoundStr(ASoundField20);

  //OutStamVoice -  21 ASound.
  ASoundField21 := Zap1.GetField(21);
  ValuesEd.Cells[1,21] := GetASoundStr(ASoundField21);

  //ArmCripVoice -  22 ASound.
  ASoundField22 := Zap1.GetField(22);
  ValuesEd.Cells[1,22] := GetASoundStr(ASoundField22);

  //LegCripVoice -  23 ASound.
  ASoundField23 := Zap1.GetField(23);
  ValuesEd.Cells[1,23] := GetASoundStr(ASoundField23);

  //BoredVoice -  24 ASound.
  ASoundField24 := Zap1.GetField(24);
  ValuesEd.Cells[1,24] := GetASoundStr(ASoundField24);

  //Unknown1 -  25 ASound.
  ASoundField25 := Zap1.GetField(25);
  ValuesEd.Cells[1,25] := GetASoundStr(ASoundField25);

  //OverloadVoice -  26 ASound.
  ASoundField26 := Zap1.GetField(26);
  ValuesEd.Cells[1,26] := GetASoundStr(ASoundField26);

  //InjuredVoice -  27 ASound.
  ASoundField27 := Zap1.GetField(27);
  ValuesEd.Cells[1,27] := GetASoundStr(ASoundField27);

  //BigAttVoice -  28 ASound.
  ASoundField28 := Zap1.GetField(28);
  ValuesEd.Cells[1,28] := GetASoundStr(ASoundField28);

  //ArmorCriVoice -  29 ASound.
  ASoundField29 := Zap1.GetField(29);
  ValuesEd.Cells[1,29] := GetASoundStr(ASoundField29);

  //WeapCripVoice -  30  ASound.
  ASoundField30 := Zap1.GetField(30);
  ValuesEd.Cells[1,30] := GetASoundStr(ASoundField30);

  //AttInDefVoice -  31  ASound.
  ASoundField31 := Zap1.GetField(31);
  ValuesEd.Cells[1,31] := GetASoundStr(ASoundField31);

  //WaitFollVoice -  32  ASound.
  ASoundField32 := Zap1.GetField(32);
  ValuesEd.Cells[1,32] := GetASoundStr(ASoundField32);

  //ScenarioVoice -  33  ASound.
  ASoundField33 := Zap1.GetField(33);
  ValuesEd.Cells[1,33] := GetASoundStr(ASoundField33);

  //StealEmpVoice -  34  ASound.
  ASoundField34 := Zap1.GetField(34);
  ValuesEd.Cells[1,34] := GetASoundStr(ASoundField34);

  //ShopYesVoice -  35  ASound.
  ASoundField35 := Zap1.GetField(35);
  ValuesEd.Cells[1,35] := GetASoundStr(ASoundField35);

  //ShopNoVoice -  36  ASound.
  ASoundField36 := Zap1.GetField(36);
  ValuesEd.Cells[1,36] := GetASoundStr(ASoundField36);

end;

Function TSinglAcksDbR1F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';

  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,1]);
    Zap1.ReWriteField(1,Length(BufSt),BufSt);

    //SelectVoice.  2. ASound.
    Zap1.ReWriteField(2,Length(ASoundField2),ASoundField2);

    //MoveVoice.  3. ASound.
    Zap1.ReWriteField(3,Length(ASoundField3),ASoundField3);

    //AttackVoice.  4. ASound.
    Zap1.ReWriteField(4,Length(ASoundField4),ASoundField4);

    //CastVoice.  5. ASound.
    Zap1.ReWriteField(5,Length(ASoundField5),ASoundField5);

    //LootVoice.  6. ASound.
    Zap1.ReWriteField(6,Length(ASoundField6),ASoundField6);

    //UseObjVoice.  7. ASound.
    Zap1.ReWriteField(7,Length(ASoundField7),ASoundField7);

    //StealVoice.  8. ASound.
    Zap1.ReWriteField(8,Length(ASoundField8),ASoundField8);

    //FollowVoice.  9. ASound.
    Zap1.ReWriteField(9,Length(ASoundField9),ASoundField9);

    //UsePotVoice.  10. ASound.
    Zap1.ReWriteField(10,Length(ASoundField10),ASoundField10);
    
    //ChPosVoice.  11. ASound.
    Zap1.ReWriteField(11,Length(ASoundField11),ASoundField11);

    //NoWayVoice.  12. ASound.
    Zap1.ReWriteField(12,Length(ASoundField12),ASoundField12);

    //CntChPosVoice.  13. ASound.
    Zap1.ReWriteField(13,Length(ASoundField13),ASoundField13);

    //NoPathVoice.  14. ASound.
    Zap1.ReWriteField(14,Length(ASoundField14),ASoundField14);

    //CantCastVoice.  15. ASound.
    Zap1.ReWriteField(15,Length(ASoundField15),ASoundField15);

    //CantTeleVoice.  16. ASound.
    Zap1.ReWriteField(16,Length(ASoundField16),ASoundField16);

    //SkiFailVoice.  17. ASound.
    Zap1.ReWriteField(17,Length(ASoundField17),ASoundField17);

    //NoTargetVoice.  18. ASound.
    Zap1.ReWriteField(18,Length(ASoundField18),ASoundField18);

    //ComplSpVoice.  19. ASound.
    Zap1.ReWriteField(19,Length(ASoundField19),ASoundField19);

    //DecToAttVoice.  20. ASound.
    Zap1.ReWriteField(20,Length(ASoundField20),ASoundField20);

    //OutStamVoice.  21. ASound.
    Zap1.ReWriteField(21,Length(ASoundField21),ASoundField21);

    //ArmCripVoice.  22. ASound.
    Zap1.ReWriteField(22,Length(ASoundField22),ASoundField22);

    //LegCripVoice.  23. ASound.
    Zap1.ReWriteField(23,Length(ASoundField23),ASoundField23);

    //BoredVoice.  24. ASound.
    Zap1.ReWriteField(24,Length(ASoundField24),ASoundField24);

    //Unknown1.  25. ASound.
    Zap1.ReWriteField(25,Length(ASoundField25),ASoundField25);

    //OverloadVoice.  26. ASound.
    Zap1.ReWriteField(26,Length(ASoundField26),ASoundField26);

    //InjuredVoice.  27. ASound.
    Zap1.ReWriteField(27,Length(ASoundField27),ASoundField27);

    //BigAttVoice.  28. ASound.
    Zap1.ReWriteField(28,Length(ASoundField28),ASoundField28);

    //ArmorCriVoice.  29. ASound.
    Zap1.ReWriteField(29,Length(ASoundField29),ASoundField29);

    //WeapCripVoice.  30. ASound.
    Zap1.ReWriteField(30,Length(ASoundField30),ASoundField30);

    //AttInDefVoice.  31. ASound.
    Zap1.ReWriteField(31,Length(ASoundField31),ASoundField31);

    //WaitFollVoice.  32. ASound.
    Zap1.ReWriteField(32,Length(ASoundField32),ASoundField32);

    //ScenarioVoice.  33. ASound.
    Zap1.ReWriteField(33,Length(ASoundField33),ASoundField33);

    //StealEmpVoice.  34. ASound.
    Zap1.ReWriteField(34,Length(ASoundField34),ASoundField34);

    //ShopYesVoice.  35. ASound.
    Zap1.ReWriteField(35,Length(ASoundField35),ASoundField35);

    //ShopNoVoice.  36. ASound.
    Zap1.ReWriteField(36,Length(ASoundField36),ASoundField36);

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TSinglAcksDbR1F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[1].EditStyle := esEllipsis;
    ValuesEd.ItemProps[2].EditStyle := esEllipsis;
    ValuesEd.ItemProps[3].EditStyle := esEllipsis;
    ValuesEd.ItemProps[4].EditStyle := esEllipsis;
    ValuesEd.ItemProps[5].EditStyle := esEllipsis;
    ValuesEd.ItemProps[6].EditStyle := esEllipsis;
    ValuesEd.ItemProps[7].EditStyle := esEllipsis;
    ValuesEd.ItemProps[8].EditStyle := esEllipsis;
    ValuesEd.ItemProps[9].EditStyle := esEllipsis;
    ValuesEd.ItemProps[10].EditStyle := esEllipsis;
    ValuesEd.ItemProps[11].EditStyle := esEllipsis;
    ValuesEd.ItemProps[12].EditStyle := esEllipsis;
    ValuesEd.ItemProps[13].EditStyle := esEllipsis;
    ValuesEd.ItemProps[14].EditStyle := esEllipsis;
    ValuesEd.ItemProps[15].EditStyle := esEllipsis;
    ValuesEd.ItemProps[16].EditStyle := esEllipsis;
    ValuesEd.ItemProps[17].EditStyle := esEllipsis;
    ValuesEd.ItemProps[18].EditStyle := esEllipsis;
    ValuesEd.ItemProps[19].EditStyle := esEllipsis;
    ValuesEd.ItemProps[20].EditStyle := esEllipsis;
    ValuesEd.ItemProps[21].EditStyle := esEllipsis;
    ValuesEd.ItemProps[22].EditStyle := esEllipsis;
    ValuesEd.ItemProps[23].EditStyle := esEllipsis;
    ValuesEd.ItemProps[24].EditStyle := esEllipsis;
    ValuesEd.ItemProps[25].EditStyle := esEllipsis;
    ValuesEd.ItemProps[26].EditStyle := esEllipsis;
    ValuesEd.ItemProps[27].EditStyle := esEllipsis;
    ValuesEd.ItemProps[28].EditStyle := esEllipsis;
    ValuesEd.ItemProps[29].EditStyle := esEllipsis;
    ValuesEd.ItemProps[30].EditStyle := esEllipsis;
    ValuesEd.ItemProps[31].EditStyle := esEllipsis;
    ValuesEd.ItemProps[32].EditStyle := esEllipsis;
    ValuesEd.ItemProps[33].EditStyle := esEllipsis;
    ValuesEd.ItemProps[34].EditStyle := esEllipsis;
    ValuesEd.ItemProps[35].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TSinglAcksDbR1F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[1].EditStyle := esSimple;
    ValuesEd.ItemProps[2].EditStyle := esSimple;
    ValuesEd.ItemProps[3].EditStyle := esSimple;
    ValuesEd.ItemProps[4].EditStyle := esSimple;
    ValuesEd.ItemProps[5].EditStyle := esSimple;
    ValuesEd.ItemProps[6].EditStyle := esSimple;
    ValuesEd.ItemProps[7].EditStyle := esSimple;
    ValuesEd.ItemProps[8].EditStyle := esSimple;
    ValuesEd.ItemProps[9].EditStyle := esSimple;
    ValuesEd.ItemProps[10].EditStyle := esSimple;
    ValuesEd.ItemProps[11].EditStyle := esSimple;
    ValuesEd.ItemProps[12].EditStyle := esSimple;
    ValuesEd.ItemProps[13].EditStyle := esSimple;
    ValuesEd.ItemProps[14].EditStyle := esSimple;
    ValuesEd.ItemProps[15].EditStyle := esSimple;
    ValuesEd.ItemProps[16].EditStyle := esSimple;
    ValuesEd.ItemProps[17].EditStyle := esSimple;
    ValuesEd.ItemProps[18].EditStyle := esSimple;
    ValuesEd.ItemProps[19].EditStyle := esSimple;
    ValuesEd.ItemProps[20].EditStyle := esSimple;
    ValuesEd.ItemProps[21].EditStyle := esSimple;
    ValuesEd.ItemProps[22].EditStyle := esSimple;
    ValuesEd.ItemProps[23].EditStyle := esSimple;
    ValuesEd.ItemProps[24].EditStyle := esSimple;
    ValuesEd.ItemProps[25].EditStyle := esSimple;
    ValuesEd.ItemProps[26].EditStyle := esSimple;
    ValuesEd.ItemProps[27].EditStyle := esSimple;
    ValuesEd.ItemProps[28].EditStyle := esSimple;
    ValuesEd.ItemProps[29].EditStyle := esSimple;
    ValuesEd.ItemProps[30].EditStyle := esSimple;
    ValuesEd.ItemProps[31].EditStyle := esSimple;
    ValuesEd.ItemProps[32].EditStyle := esSimple;
    ValuesEd.ItemProps[33].EditStyle := esSimple;
    ValuesEd.ItemProps[34].EditStyle := esSimple;
    ValuesEd.ItemProps[35].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to SinglAcksDbR1F.MaskiBox.Items.Capacity-1 do begin
    If SinglAcksDbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to SinglAcksDbR1F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If SinglAcksDbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TSinglAcksDbR1F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;
end;

procedure TSinglAcksDbR1F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TSinglAcksDbR1F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TSinglAcksDbR1F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TSinglAcksDbR1F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TSinglAcksDbR1F.ValuesEdEditButtonClick(Sender: TObject);
var
  TempStr : string;
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin

    If ValuesEd.Row = 2 then begin
      // ASound.
      TempStr := EditASound(ASoundField2);
      If TempStr <> 'NIL' then begin
        ASoundField2 := TempStr;
        ValuesEd.Cells[1,2] := GetASoundStr(ASoundField2);
      end;
    end;

    If ValuesEd.Row = 3 then begin
      // ASound.
      TempStr := EditASound(ASoundField3);
      If TempStr <> 'NIL' then begin
        ASoundField3 := TempStr;
        ValuesEd.Cells[1,3] := GetASoundStr(ASoundField3);
      end;
    end;

    If ValuesEd.Row = 4 then begin
      // ASound.
      TempStr := EditASound(ASoundField4);
      If TempStr <> 'NIL' then begin
        ASoundField4 := TempStr;
        ValuesEd.Cells[1,4] := GetASoundStr(ASoundField4);
      end;
    end;

    If ValuesEd.Row = 5 then begin
      // ASound.
      TempStr := EditASound(ASoundField5);
      If TempStr <> 'NIL' then begin
        ASoundField5 := TempStr;
        ValuesEd.Cells[1,5] := GetASoundStr(ASoundField5);
      end;
    end;

    If ValuesEd.Row = 6 then begin
      // ASound.
      TempStr := EditASound(ASoundField6);
      If TempStr <> 'NIL' then begin
        ASoundField6 := TempStr;
        ValuesEd.Cells[1,6] := GetASoundStr(ASoundField6);
      end;
    end;

    If ValuesEd.Row = 7 then begin
      // ASound.
      TempStr := EditASound(ASoundField7);
      If TempStr <> 'NIL' then begin
        ASoundField7 := TempStr;
        ValuesEd.Cells[1,7] := GetASoundStr(ASoundField7);
      end;
    end;

    If ValuesEd.Row = 8 then begin
      // ASound.
      TempStr := EditASound(ASoundField8);
      If TempStr <> 'NIL' then begin
        ASoundField8 := TempStr;
        ValuesEd.Cells[1,8] := GetASoundStr(ASoundField8);
      end;
    end;

    If ValuesEd.Row = 9 then begin
      // ASound.
      TempStr := EditASound(ASoundField9);
      If TempStr <> 'NIL' then begin
        ASoundField9 := TempStr;
        ValuesEd.Cells[1,9] := GetASoundStr(ASoundField9);
      end;
    end;

    If ValuesEd.Row = 10 then begin
      // ASound.
      TempStr := EditASound(ASoundField10);
      If TempStr <> 'NIL' then begin
        ASoundField10 := TempStr;
        ValuesEd.Cells[1,10] := GetASoundStr(ASoundField10);
      end;
    end;

    If ValuesEd.Row = 11 then begin
      // ASound.
      TempStr := EditASound(ASoundField11);
      If TempStr <> 'NIL' then begin
        ASoundField11 := TempStr;
        ValuesEd.Cells[1,11] := GetASoundStr(ASoundField11);
      end;
    end;

    If ValuesEd.Row = 12 then begin
      // ASound.
      TempStr := EditASound(ASoundField12);
      If TempStr <> 'NIL' then begin
        ASoundField12 := TempStr;
        ValuesEd.Cells[1,12] := GetASoundStr(ASoundField12);
      end;
    end;

    If ValuesEd.Row = 13 then begin
      // ASound.
      TempStr := EditASound(ASoundField13);
      If TempStr <> 'NIL' then begin
        ASoundField13 := TempStr;
        ValuesEd.Cells[1,13] := GetASoundStr(ASoundField13);
      end;
    end;

    If ValuesEd.Row = 14 then begin
      // ASound.
      TempStr := EditASound(ASoundField14);
      If TempStr <> 'NIL' then begin
        ASoundField14 := TempStr;
        ValuesEd.Cells[1,14] := GetASoundStr(ASoundField14);
      end;
    end;

    If ValuesEd.Row = 15 then begin
      // ASound.
      TempStr := EditASound(ASoundField15);
      If TempStr <> 'NIL' then begin
        ASoundField15 := TempStr;
        ValuesEd.Cells[1,15] := GetASoundStr(ASoundField15);
      end;
    end;

    If ValuesEd.Row = 16 then begin
      // ASound.
      TempStr := EditASound(ASoundField16);
      If TempStr <> 'NIL' then begin
        ASoundField16 := TempStr;
        ValuesEd.Cells[1,16] := GetASoundStr(ASoundField16);
      end;
    end;

    If ValuesEd.Row = 17 then begin
      // ASound.
      TempStr := EditASound(ASoundField17);
      If TempStr <> 'NIL' then begin
        ASoundField17 := TempStr;
        ValuesEd.Cells[1,17] := GetASoundStr(ASoundField17);
      end;
    end;

    If ValuesEd.Row = 18 then begin
      // ASound.
      TempStr := EditASound(ASoundField18);
      If TempStr <> 'NIL' then begin
        ASoundField18 := TempStr;
        ValuesEd.Cells[1,18] := GetASoundStr(ASoundField18);
      end;
    end;

    If ValuesEd.Row = 19 then begin
      // ASound.
      TempStr := EditASound(ASoundField19);
      If TempStr <> 'NIL' then begin
        ASoundField19 := TempStr;
        ValuesEd.Cells[1,19] := GetASoundStr(ASoundField19);
      end;
    end;

    If ValuesEd.Row = 20 then begin
      // ASound.
      TempStr := EditASound(ASoundField20);
      If TempStr <> 'NIL' then begin
        ASoundField20 := TempStr;
        ValuesEd.Cells[1,20] := GetASoundStr(ASoundField20);
      end;
    end;

    If ValuesEd.Row = 21 then begin
      // ASound.
      TempStr := EditASound(ASoundField21);
      If TempStr <> 'NIL' then begin
        ASoundField21 := TempStr;
        ValuesEd.Cells[1,21] := GetASoundStr(ASoundField21);
      end;
    end;

    If ValuesEd.Row = 22 then begin
      // ASound.
      TempStr := EditASound(ASoundField22);
      If TempStr <> 'NIL' then begin
        ASoundField22 := TempStr;
        ValuesEd.Cells[1,22] := GetASoundStr(ASoundField22);
      end;
    end;

    If ValuesEd.Row = 23 then begin
      // ASound.
      TempStr := EditASound(ASoundField23);
      If TempStr <> 'NIL' then begin
        ASoundField23 := TempStr;
        ValuesEd.Cells[1,23] := GetASoundStr(ASoundField23);
      end;
    end;

    If ValuesEd.Row = 24 then begin
      // ASound.
      TempStr := EditASound(ASoundField24);
      If TempStr <> 'NIL' then begin
        ASoundField24 := TempStr;
        ValuesEd.Cells[1,24] := GetASoundStr(ASoundField24);
      end;
    end;

    If ValuesEd.Row = 25 then begin
      // ASound.
      TempStr := EditASound(ASoundField25);
      If TempStr <> 'NIL' then begin
        ASoundField25 := TempStr;
        ValuesEd.Cells[1,25] := GetASoundStr(ASoundField25);
      end;
    end;

    If ValuesEd.Row = 26 then begin
      // ASound.
      TempStr := EditASound(ASoundField26);
      If TempStr <> 'NIL' then begin
        ASoundField26 := TempStr;
        ValuesEd.Cells[1,26] := GetASoundStr(ASoundField26);
      end;
    end;

    If ValuesEd.Row = 27 then begin
      // ASound.
      TempStr := EditASound(ASoundField27);
      If TempStr <> 'NIL' then begin
        ASoundField27 := TempStr;
        ValuesEd.Cells[1,27] := GetASoundStr(ASoundField27);
      end;
    end;

    If ValuesEd.Row = 28 then begin
      // ASound.
      TempStr := EditASound(ASoundField28);
      If TempStr <> 'NIL' then begin
        ASoundField28 := TempStr;
        ValuesEd.Cells[1,28] := GetASoundStr(ASoundField28);
      end;
    end;

    If ValuesEd.Row = 29 then begin
      // ASound.
      TempStr := EditASound(ASoundField29);
      If TempStr <> 'NIL' then begin
        ASoundField29 := TempStr;
        ValuesEd.Cells[1,29] := GetASoundStr(ASoundField29);
      end;
    end;

    If ValuesEd.Row = 30 then begin
      // ASound.
      TempStr := EditASound(ASoundField30);
      If TempStr <> 'NIL' then begin
        ASoundField30 := TempStr;
        ValuesEd.Cells[1,30] := GetASoundStr(ASoundField30);
      end;
    end;

    If ValuesEd.Row = 31 then begin
      // ASound.
      TempStr := EditASound(ASoundField31);
      If TempStr <> 'NIL' then begin
        ASoundField31 := TempStr;
        ValuesEd.Cells[1,31] := GetASoundStr(ASoundField31);
      end;
    end;

    If ValuesEd.Row = 32 then begin
      // ASound.
      TempStr := EditASound(ASoundField32);
      If TempStr <> 'NIL' then begin
        ASoundField32 := TempStr;
        ValuesEd.Cells[1,32] := GetASoundStr(ASoundField32);
      end;
    end;

    If ValuesEd.Row = 33 then begin
      // ASound.
      TempStr := EditASound(ASoundField33);
      If TempStr <> 'NIL' then begin
        ASoundField33 := TempStr;
        ValuesEd.Cells[1,33] := GetASoundStr(ASoundField33);
      end;
    end;

    If ValuesEd.Row = 34 then begin
      // ASound.
      TempStr := EditASound(ASoundField34);
      If TempStr <> 'NIL' then begin
        ASoundField34 := TempStr;
        ValuesEd.Cells[1,34] := GetASoundStr(ASoundField34);
      end;
    end;

    If ValuesEd.Row = 35 then begin
      // ASound.
      TempStr := EditASound(ASoundField35);
      If TempStr <> 'NIL' then begin
        ASoundField35 := TempStr;
        ValuesEd.Cells[1,35] := GetASoundStr(ASoundField35);
      end;
    end;

    If ValuesEd.Row = 36 then begin
      // ASound.
      TempStr := EditASound(ASoundField36);
      If TempStr <> 'NIL' then begin
        ASoundField36 := TempStr;
        ValuesEd.Cells[1,36] := GetASoundStr(ASoundField36);
      end;
    end;

  end;
end;

procedure TSinglAcksDbR1F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
