///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit SinglPerksPdbR2Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TSinglPerksPdbR2F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  SinglPerksPdbR2F: TSinglPerksPdbR2F;
  PathForForm, MaskaNam, FileNam,ShablonsPath,
  Unknown1 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz : integer;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TSinglPerksPdbR2F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  SinglPerksPdbR2FClosed := true;
  MainForm.PerksMenu2.Checked := false;
  Action := CaFree;
end;

procedure TSinglPerksPdbR2F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  SinglPerksPdbR2FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaseResIsh;     //  
  PathForForm := IshDir+'perks\2\';     //   
  ShablonsPath := Path+'shablons\perks\2\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TSinglPerksPdbR2F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TSinglPerksPdbR2F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TSinglPerksPdbR2F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //Code -  2  TEXT.
  ValuesEd.Cells[1,2] := PzDbStrToStr(Zap1.GetField(2));

  //Texture Type Index -  3  UnsLong.
  ValuesEd.Cells[1,3] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(3)));

  //Perk -  4  TEXT.
  ValuesEd.Cells[1,4] := PzDbStrToStr(Zap1.GetField(4));

  //Skill -  5  TEXT.
  ValuesEd.Cells[1,5] := PzDbStrToStr(Zap1.GetField(5));

  //Skill ID -  6  UnsLong.
  ValuesEd.Cells[1,6] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(6)));

  //Unknown1 -  7   ,  4  .
  Unknown1 := Zap1.GetField(7);
  Unk1Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,7] := GetUnkStr(Unknown1,Unk1Siz);

  //SL -  8  UnsLong.
  ValuesEd.Cells[1,8] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(8)));

  //Str -  9  FLOAT.
  ValuesEd.Cells[1,9] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(9)),7));

  //Dex -  10  FLOAT.
  ValuesEd.Cells[1,10] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(10)),7));

  //Int -  11  FLOAT.
  ValuesEd.Cells[1,11] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(11)),7));

  //Cost -  12  UnsLong.
  ValuesEd.Cells[1,12] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(12)));

  //Modifier -  13  UnsLong.
  ValuesEd.Cells[1,13] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(13)));

  //Mult -  14  UnsLong.
  ValuesEd.Cells[1,14] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(14)));

  //Add -  15  UnsLong.
  ValuesEd.Cells[1,15] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(15)));

  //Active -  16  BOOLEAN.
  ValuesEd.Cells[1,16] := BoolToStr(_1byteStrToBool(Zap1.GetField(16)));

  //Perk Exclusive -  17  UnsLong.
  ValuesEd.Cells[1,17] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(17)));

end;

Function TSinglPerksPdbR2F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';
  
  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,3]) = false then begin
    AllOk := false;
    //Texture Type Index
    ValuesEd.Selection := SelGridRect(1,3);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Skill ID
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end
  else begin
    // ID   Weapon Type.
    If ValuesEd.Cells[1,5] = 'melee' then ValuesEd.Cells[1,6] := IntToStr(0);
    If ValuesEd.Cells[1,5] = 'archery' then ValuesEd.Cells[1,6] := IntToStr(1);
    If ValuesEd.Cells[1,5] = 'elemental' then ValuesEd.Cells[1,6] := IntToStr(3);
    If ValuesEd.Cells[1,5] = 'sense' then ValuesEd.Cells[1,6] := IntToStr(4);
    If ValuesEd.Cells[1,5] = 'astral' then ValuesEd.Cells[1,6] := IntToStr(5);
    If ValuesEd.Cells[1,5] = 'none' then ValuesEd.Cells[1,6] := IntToStr(2147483647);
  end;

  if CheckStrInt(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //SL
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,9]) = false then begin
    AllOk := false;
    //Str
    ValuesEd.Selection := SelGridRect(1,9);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,10]) = false then begin
    AllOk := false;
    //Dex
    ValuesEd.Selection := SelGridRect(1,10);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,11]) = false then begin
    AllOk := false;
    //Int
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,12]) = false then begin
    AllOk := false;
    //Cost
    ValuesEd.Selection := SelGridRect(1,12);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,13]) = false then begin
    AllOk := false;
    //Modifier
    ValuesEd.Selection := SelGridRect(1,13);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,14]) = false then begin
    AllOk := false;
    //Mult
    ValuesEd.Selection := SelGridRect(1,14);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,15]) = false then begin
    AllOk := false;
    //Add
    ValuesEd.Selection := SelGridRect(1,15);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,16]) = false then begin
    AllOk := false;
    //Active
    ValuesEd.Selection := SelGridRect(1,16);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,17]) = false then begin
    AllOk := false;
    //Perk Exclusive
    ValuesEd.Selection := SelGridRect(1,17);
    ErrorMsgStr := '    .';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,1]);
    //  ...
    Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Code.  2. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,2]);
    //  ...
    Zap1.ReWriteField(2,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Texture Type Index.  3. UnsLong.
    Zap1.ReWriteField(3,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,3])));

    //Perk.  4. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,4]);
    //  ...
    Zap1.ReWriteField(4,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Skill.  5. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,5]);
    //  ...
    Zap1.ReWriteField(5,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Skill ID.  6. UnsLong.
    Zap1.ReWriteField(6,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,6])));

    //Unknown1.  7.    .
    Zap1.ReWriteField(7,Unk1Siz,Unknown1);

    //SL.  8. UnsLong.
    Zap1.ReWriteField(8,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,8])));

    //Str.  9. FLOAT.
    Zap1.ReWriteField(9,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,9])));

    //Dex.  10. FLOAT.
    Zap1.ReWriteField(10,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,10])));

    //Int.  11. FLOAT.
    Zap1.ReWriteField(11,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,11])));

    //Cost.  12. UnsLong.
    Zap1.ReWriteField(12,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,12])));

    //Modifier.  13. UnsLong.
    Zap1.ReWriteField(13,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,13])));

    //Mult.  14. UnsLong.
    Zap1.ReWriteField(14,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,14])));

    //Add.  15. UnsLong.
    Zap1.ReWriteField(15,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,15])));

    //Active.  16. BOOLEAN.
    Zap1.ReWriteField(16,1,BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,16])));

    //Perk Exclusive.  17. UnsLong.
    Zap1.ReWriteField(17,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,17])));

    //  ...
    Zap1.BuildZap;
    result := true;
  end          
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TSinglPerksPdbR2F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[6].EditStyle := esEllipsis;

    TableActivated := true;
  end;
end;

Procedure TSinglPerksPdbR2F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[6].EditStyle := esSimple;

    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to SinglPerksPdbR2F.MaskiBox.Items.Capacity-1 do begin
    If SinglPerksPdbR2F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to SinglPerksPdbR2F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If SinglPerksPdbR2F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TSinglPerksPdbR2F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;
end;

procedure TSinglPerksPdbR2F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TSinglPerksPdbR2F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TSinglPerksPdbR2F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TSinglPerksPdbR2F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TSinglPerksPdbR2F.ValuesEdEditButtonClick(Sender: TObject);
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin
  
    If ValuesEd.Row = 7 then begin
      //1,   UnsLong.  4 .
      //,     ...
      UncAskF.UncAskFBuff := Unknown1;
      UncAskF.UncAskFBytes := Unk1Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown1 := UncAskF.UncAskFBuff;
          Unk1Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,7] := GetUnkStr(Unknown1,Unk1Siz);
        end;
      end;
    end;

  end;
end;

procedure TSinglPerksPdbR2F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
